
{% set project = properties["project"] %}
{% set deployment = env["deployment"] %}
{% set name = "%s-vm-tmpl" % properties["name"] %}
{% set instanceName = "%s" % properties["instanceName"].lower().strip().replace(" ","") %}
{% set userName = "%s" % properties["userName"].lower().strip().replace(" ","") %}
{% set instanceKeyUsername = "%s:%s" % (properties["userName"].strip().replace(" ",""), properties["instanceKeys"]) %}
{% set zone = properties["zone"] %}
{% set machineType = properties["machineType"] %}
{% set network = properties["network"] %}
{% set subnetwork = properties["subnetwork"] %}
{% set bootDiskType = properties["bootDiskType"] %}
{% set bootDiskSizeGb = properties["bootDiskSizeGb"] %}
{% set hasExternalIP = properties["externalIP"] %}
{# Software status only works if the VM has an external IP. #}
{% set enableStatusWaiter = hasExternalIP %}
{% set canIpForward = properties["ipForward"] == "On" %}


resources:
  - name: {{ name }}
    type: vm_instance.py
    properties:
      instanceName: {{ instanceName }}
      sourceImage: https://www.googleapis.com/compute/v1/projects/cisco-public/global/images/v1691fc2
      zone: {{ zone }}
      machineType: {{ machineType }}
      network: {{ network }}
      {% if subnetwork %}
      subnetwork: {{ subnetwork }}
      {% endif %}
      numAdditionalNICs : {{ properties.get("numAdditionalNICs") }}
      {% if properties.get("numAdditionalNICs") > 0 %}
      additionalNetworks:
        {% for num in range(1, properties["numAdditionalNICs"] + 1) %}
        - {{ 'additionalNetwork{}'.format(num) }} : {{ properties['additionalNetwork{}'.format(num)] }}
          {{ 'additionalSubnetwork{}'.format(num) }} : {{ properties['additionalSubnetwork{}'.format(num)] }}
        {% endfor %}
      {% endif %}
      bootDiskType: {{ bootDiskType }}
      bootDiskSizeGb: {{ bootDiskSizeGb }}
      hasExternalIP: {{ hasExternalIP }}
      canIpForward: {{ canIpForward }}
      serviceAccounts:
        - email: default
          scopes:
            - 'https://www.googleapis.com/auth/cloud.useraccounts.readonly'
            - 'https://www.googleapis.com/auth/devstorage.read_only'
            - 'https://www.googleapis.com/auth/logging.write'
            - 'https://www.googleapis.com/auth/monitoring.write'
      metadata:
        items:
          - key: ssh-keys
            value: {{ instanceKeyUsername }}
      tags:
        items:
          - {{ env["deployment"] }}-tcp-22
          - {{ env["deployment"] }}-tcp-80
  {% if properties["enableTcp22"] %}
  - name: {{ env["deployment"] }}-tcp-22
    type: compute.v1.firewall
    properties:
      network: {{ network }}
      {% if properties.get("tcp22SourceRanges") %}
      sourceRanges:
        {% for source in properties["tcp22SourceRanges"].split(',') %}
        - '{{ source | trim }}'
        {% endfor %}
      {% else %}
      sourceRanges: ["0.0.0.0/0"]
      {% endif %}
      targetTags: ["{{ env["deployment"] }}-tcp-22"]
      allowed:
        - IPProtocol: TCP
          ports: ["22"]
  {% endif %}
  {% if properties["enableTcp80"] %}
  - name: {{ env["deployment"] }}-tcp-80
    type: compute.v1.firewall
    properties:
      network: {{ network }}
      {% if properties.get("tcp80SourceRanges") %}
      sourceRanges:
        {% for source in properties["tcp80SourceRanges"].split(',') %}
        - '{{ source | trim }}'
        {% endfor %}
      {% else %}
      sourceRanges: ["0.0.0.0/0"]
      {% endif %}
      targetTags: ["{{ env["deployment"] }}-tcp-80"]
      allowed:
        - IPProtocol: TCP
          ports: ["80"]
  {% endif %}
  {% if properties["enableTcp21"] %}
  - name: {{ env["deployment"] }}-tcp-21
    type: compute.v1.firewall
    properties:
      network: {{ network }}
      {% if properties.get("tcp21SourceRanges") %}
      sourceRanges:
        {% for source in properties["tcp21SourceRanges"].split(',') %}
        - '{{ source | trim }}'
        {% endfor %}
      {% else %}
      sourceRanges: ["0.0.0.0/0"]
      {% endif %}
      targetTags: ["{{ env["deployment"] }}-tcp-21"]
      allowed:
        - IPProtocol: TCP
          ports: ["21"]
  {% endif %}

outputs:
  - name: deployment
    value: {{ deployment }}
  - name: project
    value: {{ project }}
  - name: vmId
    value: $(ref.{{ instanceName }}.id)
  - name: vmExternalIP
    {% if hasExternalIP %}
    value: $(ref.{{ name }}.ip)
    {% else %}
    value: NONE
    {% endif %}
  - name: vmInternalIP
    value: $(ref.{{ name }}.internalIP)
  - name: vmName
    value: {{ instanceName }}
  - name: userName
    value: {{ userName }}
  - name: vmSelfLink
    value: $(ref.{{ instanceName }}.selfLink)
  - name: numNics
    value: $(ref.{{ name }}.num_of_nics)
  - name: message
    value: $(ref.{{ name }}.message)